import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class FrameScelta extends JFrame implements ActionListener , MouseListener{
	//dimensione schermo
	Toolkit tool;
    Dimension d;
   
   	//Panel comandi controllo
    PanelControlli controlli; 
   	
    //pannello zero
    PanelZero panelZero;
    
    //pannello GANTT
    PanelCostruzione panel;
    
    //componenti frame
    Container container;
    Principale frame;
    String aggiorna;
    
    private static FrameScelta frameScelta;
    
    private FrameScelta(){
    	super("Che cosa vuoi fare?");
    	
		container = this.getContentPane();
	    container.setLayout(null);
	    
	    //EnabledFrameFather(false);
	    panel = null;
	    panelZero = new PanelZero(this);
		
		controlli = new PanelControlli(this);
		
	    container.add(panelZero);
	    container.add(controlli);
	    
	    this.setResizable(false);
	    //this.setBounds((int)frame.getLocation().getX()+112,(int)frame.getLocation().getY()+84,800,600);
	   	this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
	   	this.setBounds(100,100,800,600);
	    this.setVisible(true);
    }
    public static FrameScelta getFrameScelta(Principale p,String diag){
    	if(frameScelta == null)
    		frameScelta = new FrameScelta();
    	frameScelta.setVisible(true);
    	frameScelta.popola(p,diag);
    	return frameScelta;
    }
    public void popola(Principale p, String diag){
    	if(p!=null){	
			
			controlli.disabledIndietro();
			
			frame = p;
			aggiorna = diag;
			
			if(diag.equals("Nuovo")){
				
				p = null;
				frame = null;
				
				panel.setVisible(false);
				panel = null;
				panelZero.setVisible(true);
			
			}else{
				panel.setDiagramma(diag);
				panel.popola(p.getNome(),p.getInizio(),p.getDeadLine(),p.getListaAttivita(),p.getListaDurate(),p.getMatriceAdiacenza(),p.getListaCosti(),p.getListaDescrizioni());
				panel.setVisible(true);
				
				panel.setEnabledPanel1(true);
				panel.setEnabledPanel2Resto(true);
				panel.setEnabledPanel2Prec(false);
						
				panelZero.setVisible(false);
				
				container.add(panel);
			}
		}
    }
    public PanelCostruzione getPanel(){
    	return panel;
    }
    public void pulisci(){
    	if(panel!=null)
    		panel.reset();
    }
    public PanelZero zero(){
    	return panelZero;
    }
    public void EnabledFrameFather(Boolean b){
    	frame.setEnabled(b);
    }
    public void zeroVisible(){
    	panel.SetNullPanel();
    	panel.hide();
    	panel = null;
    	controlli.disabledIndietro();
    	panelZero.setVisible(true);
    }
    
	public void actionPerformed(ActionEvent e){
		String scelta = (String) e.getActionCommand();
		if(scelta.equals("Avanti")){	
				//Aggiungo il pannello per la costruzione del diagramma gantt
			if(panel==null){
				panel = new PanelCostruzione(panelZero.getSelezione(),this);
				container.add(panel);
			}
			if(panel.isVisible()){
				if(panel.getStato()==1){
					if(panel.verificaPanel1()){
						if(panel.verificaDeadLine()){
							if(panel.verificaAttivita()){
								if(panel.verificaInizio()){
									if(panel.verificaFine()){
										if(panel.verificaDurate()){
											if(panel.verificaCosti()){
												panel.nextStato();
												panel.setEnabledPanel1(false);
												panel.setEnabledPanel2Resto(false);
												panel.setEnabledPanel2Prec(true);
											}else{
												JOptionPane.showMessageDialog(this,"Errore costo Attivita");
											}
										}else{
											JOptionPane.showMessageDialog(this,"Errore durata Attivita");
										}
									}else{
										JOptionPane.showMessageDialog(this,"Fine Progetto deve essere unica");
									}
								}else{
									JOptionPane.showMessageDialog(this,"Inizio Progetto deve essere unica");
								}
							}else{
								JOptionPane.showMessageDialog(this,"Numero Attivita Progetto >= 2");
							}
						}else{
							JOptionPane.showMessageDialog(this,"Durata Progetto non valida");
						}
					}else{
						JOptionPane.showMessageDialog(this,"Verifica Nome - Inizio - DeadLine - Progetto");
					}
				}
				else if(panel.getStato()==2){
					if(frame == null){
						if(panel.verificaPrecedenze()){
							if(panel.verificaAttivitaInizio()){
								if(panel.verificaAttivitaFine()){
									frame = new Principale(panelZero.getSelezione(),panel.getNome(),panel.getListaAttivita(),panel.getInizio(),panel.getDeadLine(),panel.getMatriceSel(),panel.getMatriceAdiacenza(),panel.getListaDurate(),panel.getListaCosti(),panel.getDescrizioni());
									this.setVisible(false);
								}else{
									JOptionPane.showMessageDialog(this,"Attivita Fine : Almeno un arco in entrata - Nessun arco in uscita");
								}
							}else{
								JOptionPane.showMessageDialog(this,"Attivita Inizio : Nessuna arco in entrata - Almeno uno in uscita");
							}
						}else{
							JOptionPane.showMessageDialog(this,"Verifica Successori - Almeno Uno");
						}	
					}else{
						if(panel.verificaPrecedenze()){	
							frame.aggiorna(aggiorna,panel.getNome(),panel.getListaAttivita(),panel.getInizio(),panel.getDeadLine(),panel.getMatriceSel(),panel.getMatriceAdiacenza(),panel.getListaDurate(),panel.getListaCosti(),panel.getDescrizioni());
							this.setVisible(false);
						}else{
						JOptionPane.showMessageDialog(this,"Verifica Successori - Almeno Uno");
						}
					}
				}
			}else{
			
				panelZero.setVisible(false);
				panel.setVisible(true);
				controlli.enabledIndietro();
			}
			panelZero.resetSelection();
		}
		if(scelta.equals("Indietro")){
			panel.indietro();
		}
		if(scelta.equals("Annulla")){
			if(frame==null)
				System.exit(0);
			else{
				this.setVisible(false);
			}
		}
		if(scelta.equals("Gantt")){
			controlli.enabledAvanti();		
		}
		if(scelta.equals("Pert")){
			controlli.enabledAvanti();
		}
	}
 	public void mousePressed(MouseEvent e) {
    }

    public void mouseReleased(MouseEvent e) {
    }

    public void mouseEntered(MouseEvent e) {
    	Component c = e.getComponent();
    	if(c.equals(panelZero.getGantt())){
    		panelZero.setImage("images/gantt.gif");
    	}
    	if(c.equals(panelZero.getPert())){
    		panelZero.setImage("images/pert.png");
    	}
    }

    public void mouseExited(MouseEvent e) {
    }

    public void mouseClicked(MouseEvent e) {
    }
}