import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class PanelControlli extends JPanel{
	JButton avanti;
	JButton indietro;
	JButton annulla;
	
	FrameScelta principale;
	
	ActionListener listener;
	
	public PanelControlli(FrameScelta f){
		this.setLayout(null);
		this.setBackground(Color.white);
		this.setBounds(0,500,800,100);
		this.setVisible(true);
		this.setBorder(BorderFactory.createEtchedBorder());
		
		listener = f;
		
		avanti = new JButton("Avanti");
		avanti.setEnabled(false);
	
		indietro = new JButton("Indietro");
		indietro.setEnabled(false);
		annulla = new JButton("Annulla");
		
		indietro.addActionListener(listener);
		avanti.addActionListener(listener);
		annulla.addActionListener(listener);
		
		indietro.setBounds(400,30,80,30);
		avanti.setBounds(500,30,80,30);
		annulla.setBounds(700,30,80,30);

		principale = f;
		
		this.add(indietro);
		this.add(avanti);
		this.add(annulla);
	}
	public void enabledAvanti(){
		avanti.setEnabled(true);
		avanti.setToolTipText("");
	}
	public void enabledIndietro(){
		indietro.setEnabled(true);
	}
	public void disabledAvanti(){
		avanti.setEnabled(false);
	}
	public void disabledIndietro(){
		indietro.setEnabled(false);
	}	
}