import java.awt.event.*;
import javax.swing.*;
import java.awt.*;

public class VisualizzaDiagramma extends JFrame{
	Container c;
	
	PanelDisegnoGantt panelGantt;
	PanelDisegnoPert panelPert;
	
	JButton close;
	
	public VisualizzaDiagramma(String diag,Principale p){
		super("Diagramma " + diag);
		this.setBounds(100,100,512,440);
		this.setResizable(false);
		
		c = this.getContentPane();
		c.setLayout(null);
		
		if(diag.equals("Gantt")){
			panelGantt = new PanelDisegnoGantt(p.getListaAttivita(),p.getInizio(),p.getDeadLine(),p.getMatriceSel());
			panelGantt.getScroll().setBounds(0,0,500,400);
			
			c.add(panelGantt.getScroll());
		}
		else{
			panelPert = new PanelDisegnoPert(p.getMatriceAdiacenza(),p.getListaAttivita(),p.getListaDurate());
			panelPert.getScroll().setBounds(0,0,500,400);
			
			c.add(panelPert.getScroll());
		}
		
		this.show();
	}
}