import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.table.*;
import java.lang.*;

class Panel1 extends JPanel implements ActionListener{
	JLabel intestazione;
	
	JTextArea guida;
	String passo1;
	String passo2;
	
	JLabel nome;
	JLabel inizio;
	JLabel dead;
	
	JButton cal1;
	JButton cal3;
	
	JTextField nomeProgetto;
	JTextField inizioProgetto;
	JTextField deadLine;
	
	int stato;
	String diagramma;
	
	Panel1(int s,String n){
		this.setLayout(null);
		this.setBounds(0,0,800,150);
		this.setBackground(Color.white);
		this.setBorder(BorderFactory.createEtchedBorder());
		
		stato = s;
		diagramma = n;
		
		intestazione = new JLabel("Costruzione Diagramma " + diagramma + " - passo " + stato +  " di 2");
		intestazione.setFont(new Font("INTESTAZIONE",Font.ITALIC,10));
		intestazione.setForeground(Color.gray);
		intestazione.setBounds(5,1,500,11);
		
		passo1 = "Compilare tutti i campi escluso le precedenze";
		passo2 = "Compilare i successori";
		
		guida = new JTextArea(passo1,5,10);
		guida.setEditable(false);
		guida.setBackground(Color.yellow);
		guida.setBorder(BorderFactory.createEtchedBorder());
		guida.setBounds(400,40,300,70);
		
		nome = new JLabel("Nome Progetto");
		nome.setBounds(80,45,100,20);
		nomeProgetto = new JTextField("");
		nomeProgetto.setBounds(180,45,100,20);
		
		inizio = new JLabel("Inizio Progetto");
		inizio.setBounds(80,70,100,20);
		inizioProgetto = new JTextField("");
		inizioProgetto.setEditable(false);
		inizioProgetto.setBounds(180,70,100,20);
		cal1 = new JButton("cal1");
		cal1.setBounds(280,70,20,20);
		cal1.addActionListener(this);
		
		dead = new JLabel("DeadLine");
		dead.setBounds(80,95,100,20);
		deadLine = new JTextField("");
		deadLine.setEditable(false);
		deadLine.setBounds(180,95,100,20);
		cal3 = new JButton("cal3");
		cal3.setBounds(280,95,20,20);
		cal3.addActionListener(this);
		
		if(diagramma.equals("Pert")){
			cal1.setEnabled(false);
			cal3.setEnabled(false);
		}

		this.add(intestazione);
		this.add(guida);
		this.add(nome);
		this.add(nomeProgetto);
		this.add(inizio);
		this.add(inizioProgetto);
		this.add(cal1);
		this.add(dead);
		this.add(deadLine);
		this.add(cal3);
		
		this.setEnabled(true);
	}
	public int calcolaDurata(String i,String f){
		StringTokenizer sti = new StringTokenizer(i);
		StringTokenizer stf = new StringTokenizer(f);
		
		int gi = Integer.parseInt(sti.nextToken());
		int mi = calcolaMese(sti.nextToken());
		int ai = Integer.parseInt(sti.nextToken());
		
		int gf = Integer.parseInt(stf.nextToken());
		int mf = calcolaMese(stf.nextToken());
		int af = Integer.parseInt(stf.nextToken()); 
			
		int dur = 0;
		
		if(af >= ai){
			if(mf >= mi){
				if(gf > gi){
					while(!(gi == gf && mi == mf && ai == af)){
						
						if(mi ==1 || mi == 3 || mi == 5 || mi == 7 || mi == 8 || mi == 10 || mi == 12)
							if(gi == 31){
								if(mi==12){
									ai++;
									mi = 1;
								}
								else
									mi++;
								gi = 0;
							}
							else
								gi++;
						else if(mi == 4 || mi == 6 || mi == 9 || mi == 11)
							if(gi==30){
								gi = 0;
								mi++;
							}
							else
								gi++;
						else
							if(gi==28){
								gi = 0;
								mi++;
							}
							else
								gi++;
						dur++;
					}
				}
				else{
					return -1;
				}
			}
			else{
				return -1;
			}
		}else{
			return -1;
		}
		return dur+1;
	}
	public int calcolaMese(String m){
		if(m.equals("Gennaio"))
			return 1;
		if(m.equals("Febbraio"))
			return 2;
		if(m.equals("Marzo"))
			return 3;
		if(m.equals("Aprile"))
			return 4;
		if(m.equals("Maggio"))
			return 5;
		if(m.equals("Giugno"))
			return 6;
		if(m.equals("Luglio"))
			return 7;
		if(m.equals("Agosto"))
			return 8;
		if(m.equals("Settembre"))
			return 9;
		if(m.equals("Ottobre"))
			return 10;
		if(m.equals("Novembre"))
			return 11;
		else
			return 12;
	}
	public String getNome(){
		return nomeProgetto.getText();
	}
	public void setNome(String nome){
		nomeProgetto.setText(nome);
	}
	public void setInizio(String inizio){
		inizioProgetto.setText(inizio);
	}
	public void setDeadLine(String dead){
		deadLine.setText(dead);
	}
	public String getInizio(){
		return inizioProgetto.getText();
	}
	public String getDeadLine(){
		return deadLine.getText();
	}
	public void actionPerformed(ActionEvent e){
		String scelta = (String) e.getActionCommand();
		if(scelta.equals("cal1")){
			new FrameCalendar(inizioProgetto);
		}
		if(scelta.equals("cal3")){
			new FrameCalendar(deadLine);
		}
	}
	public void setIntestazione(int s,String n){
		intestazione.setText("Costruzione Diagramma "+n+" - passo " + s + " di 2");
		if(s==1){
			guida.setText(passo1);
		}
		else{
			guida.setText(passo2);
		}
	}
	public void setEnabled(boolean t){
		nome.setEnabled(t);
		nomeProgetto.setEnabled(t);
		inizio.setEnabled(t);
		inizioProgetto.setEnabled(t);
		dead.setEnabled(t);
		deadLine.setEnabled(t);
		if(diagramma.equals("Pert")){
			cal1.setEnabled(false);
			cal3.setEnabled(false);
		}else{
			cal1.setEnabled(t);
			cal3.setEnabled(t);
		}
	}
	public boolean isEnabled(){
		return nome.isEnabled();
	}
	public void reset(){
		nomeProgetto.setText("");
		inizioProgetto.setText("");
		deadLine.setText("");
		intestazione.setText("");
	}
	public boolean verificaPanel1(){
		boolean t = false;
		if(!diagramma.equals("Pert")){
			if(!inizioProgetto.getText().equals("") && !deadLine.getText().equals("") && !nomeProgetto.getText().equals("")){
				t = true;
			}
		}else{
			if(!nomeProgetto.getText().equals("")){
				t = true;
			}
		}
		return t;
	}
	public boolean verificaDeadLine(){
		if(!diagramma.equals("Pert")){
			if(calcolaDurata(inizioProgetto.getText(),deadLine.getText())<=0)
				return false;
			else
				return true;
		}
		else{
			return true;
		}
	}
}

class JComboBoxEditor extends DefaultCellEditor {
    public JComboBoxEditor(Object[] items) {
        super(new JComboBox(items));
    }
}

class FinestraPrecedenze extends JOptionPane{
	JComponent[] lista;
	
	public FinestraPrecedenze(ActionListener al,JTable table){
		
		int numAtt = 0;
		for(int j = 0; j < table.getRowCount(); j++){
			if((String)table.getValueAt(j,0)!=null){
				if(!((String)table.getValueAt(j,0)).equals(""))
					numAtt++;
			}
		}
		
		String[] att = new String[numAtt]; //prima 100
		
		for(int i = 0; i < numAtt; i++){
			if(table.getValueAt(i,0)!=null){
				if(!((String)table.getValueAt(i,0)).equals(""))
					att[i] = (String)table.getValueAt(i,0);
			}
		}	
		lista = new JComponent[att.length+1];
		
		for(int i = 0; i < att.length; i++){
			lista[i] = new JCheckBox(att[i]);
		}
		lista[att.length] = new JButton("OK");
		((JButton)lista[att.length]).addActionListener(al);
		
		this.setMessage("Scelta Successori");
		this.setOptions(lista);
	    this.setMessageType(JOptionPane.INFORMATION_MESSAGE);
	}
	public void reset(){
		for(int i = 0; i < lista.length-1; i++){
			((JCheckBox)lista[i]).setSelected(false);
		}
	}
	public String getSelezione(){
		String sel = "";
		
		for(int i = 0; i < lista.length-1; i++){
			if(((JCheckBox)lista[i]).isSelected()){
				sel = sel + " " + ((JCheckBox)lista[i]).getText();
			}
		}
		
		return sel;
	}
}
class ButtonEditor extends AbstractCellEditor
                         implements TableCellEditor,
                                    ActionListener {
    String precedenze;
    JButton button;
    
    JDialog dialog;
    FinestraPrecedenze optionPane;
    JTable table;
    protected static final String EDIT = "edit";

    public ButtonEditor(JTable t) {
        button = new JButton();
        button.setActionCommand(EDIT);
        button.addActionListener(this);
        button.setBorderPainted(false);
        
        table = t;
    }

    public void actionPerformed(ActionEvent e) {
        if (EDIT.equals(e.getActionCommand())) {
            //The user has clicked the cell, so
            //bring up the dialog.
            
            optionPane = new FinestraPrecedenze(this,table);
	    	dialog = optionPane.createDialog(button, "Icon/Text Button");
            dialog.setVisible(true);

            fireEditingStopped(); //Make the renderer reappear.

        }if(e.getActionCommand().equals("OK")){ //User pressed dialog's "OK" button.
            precedenze = optionPane.getSelezione();
        	optionPane.reset();
        	dialog.hide();
        	
        	optionPane = null;
        	dialog = null;
        	
        }
    }

    //Implement the one CellEditor method that AbstractCellEditor doesn't.
    public Object getCellEditorValue() {
        return precedenze;
    }

    //Implement the one method defined by TableCellEditor.
    public Component getTableCellEditorComponent(JTable table,
                                                 Object value,
                                                 boolean isSelected,
                                                 int row,
                                                 int column) {
        return button;
    }
}


class CustomModel extends DefaultTableModel {
	private boolean prec;
	private boolean resto;
	
	public CustomModel(Object[][] r,Object[] c){
		super(r,c);
		prec = false;
		resto = true;
	}
  public void setEditablePrec(boolean t){
  	prec = t;
  }
  public void setEditableResto(boolean t){
  	resto = t;
  }
  public boolean isCellEditable(int row, int column) {
    if(resto){
    	if(column!=4)
    		return true;
    }
    if(prec){
    	if(column==4)
    		return true;
    }
    return false;
  }
}
class Panel2 extends JPanel implements ActionListener, MouseListener{
	CustomModel model;
	TableColumn col1;
	TableColumn col2;
	JTable table;
	JScrollPane pane;
	Object[] colonne;
	Object[][] righe;
	JButton box;
	JComboBox check;
	int assegnaI;
	int assegnaF;
	
	String diagramma;

	Panel1 panel;
	 
	public Panel2(String n,Panel1 p){
		this.setLayout(null);
		this.setBounds(0,150,800,350);
		this.setBackground(Color.white);
		this.setBorder(BorderFactory.createEtchedBorder());
		
		panel = p;
		
		diagramma = n;
		assegnaI = -1;
		assegnaF = -1;
		
		colonne = new Object[6];
		colonne[0] = "NOME ATTIVITA";
		colonne[1] = "INIZIO-FINE";
		colonne[2] = "DURATA";
		colonne[3] = "COSTO";
		colonne[4] = "SUCCESSORI";
		colonne[5] = "DESCRIZIONE";
		
		righe = new Object[100][6];            //numero massimo attivita 100
		for(int i = 0; i < 100; i++){
			for(int j = 0; j < 6 ; j ++){
				righe[i][j] = null;
			}
		}		
		
		model = new CustomModel(righe,colonne);
		
		table = new JTable(model);

		String[] values = {"","Inizio","Fine"};
		
		col1 = table.getColumnModel().getColumn(1);
   		col1.setCellEditor(new JComboBoxEditor(values));
		//col.setCellRenderer(new MyComboBoxRenderer(values));
		
		pane = new JScrollPane(table);
		pane.setBounds(5,5,790,340);
		
		this.add(pane);
		
		//this.setEnabled(false);
	}
	public void addFinestra(){
		col2 = table.getColumnModel().getColumn(4);
   		col2.setCellEditor(new ButtonEditor(table));
	}
	public void actionPerformed(ActionEvent e){
		String scelta = (String) e.getActionCommand();
	}
	public void mousePressed(MouseEvent e) {
    }

    public void mouseReleased(MouseEvent e) {
    }

    public void mouseEntered(MouseEvent e) {
    }

    public void mouseExited(MouseEvent e) {
    }

    public void mouseClicked(MouseEvent e) {
    }
	public void setEnabledResto(boolean t){
		model.setEditableResto(t);
	}
	public void setEnabledPrec(boolean t){
		model.setEditablePrec(t);
	}
	public boolean isEnabled(){
		return table.isEnabled();
	}
	public void reset(){
		table.removeAll();
	}
	public boolean verificaInizio(){
		int inizio = 0;
		for(int i = 0; i < table.getRowCount(); i++){
			if(table.getValueAt(i,1)!=null){
				if(!((String)table.getValueAt(i,1)).equals("")){
					if(((String)table.getValueAt(i,1)).equals("Inizio")){
						inizio++;
					}
				}	
			}
		}
		
		if(inizio == 1){
			return true;
		
		}else{
			return false;
		}
	}
	public boolean verificaAttivitaInizio(){
		String attivita = "";
		int indice = 0;
		for(int i = 0; i < table.getRowCount(); i++){
			if(table.getValueAt(i,1)!=null){
				if(!((String)table.getValueAt(i,1)).equals("")){
					if(((String)table.getValueAt(i,1)).equals("Inizio")){
						attivita = (String)table.getValueAt(i,0);
						indice = i;
						break;
					}
				}
			}
		}
		
		boolean arcoEntrata = true;
		for(int i = 0; i < table.getRowCount();i++){
			if(i!=indice){
				if(table.getValueAt(i,0)!=null){
					System.out.println((String)table.getValueAt(i,0));	
					if(presente(listaPrecedenze((String)table.getValueAt(i,0)),attivita)){
						arcoEntrata =  false;
						break;
					}
				}
			}
		}
		
		
		boolean arcoUscita = false;
		if(table.getValueAt(indice,4)!=null){
			if(!((String)table.getValueAt(indice,4)).equals("")){
				arcoUscita = true;
			}
		}
		
		System.out.println(arcoEntrata + " " + arcoUscita);
		
		return arcoEntrata && arcoUscita;
	}
	public boolean verificaAttivitaFine(){
		String attivita = "";
		int indice = 0;
		for(int i = 0; i < table.getRowCount(); i++){
			if(table.getValueAt(i,1)!=null){
				if(!((String)table.getValueAt(i,1)).equals("")){
					if(((String)table.getValueAt(i,1)).equals("Fine")){
						attivita = (String)table.getValueAt(i,0);
						indice = i;
						break;
					}
				}
			}
		}
		
		boolean arcoEntrata = false;
		for(int i = 0; i < table.getRowCount();i++){
			if(i!=indice){
				if(table.getValueAt(i,0)!=null){
					if(!((String)table.getValueAt(i,0)).equals("")){
						if(presente(listaPrecedenze((String)table.getValueAt(i,0)),attivita)){
							arcoEntrata =  true;
							break;
						}
					}
				}
			}
		}
		
		boolean arcoUscita = true;
		if(table.getValueAt(indice,4)!=null){
			if(!((String)table.getValueAt(indice,4)).equals("")){
				arcoUscita = false;
			}
		}
		
		return arcoEntrata && arcoUscita;
	}
	public boolean verificaAttivita(){
		int num = 0;
		for(int j = 0; j < table.getRowCount(); j++){
			if(table.getValueAt(j,0)!=null){
				if(!((String)table.getValueAt(j,0)).equals("")){
					num++;
				}
			}
		}
		if(num>=2)
			return true;
		else
			return false;
	}
	
	public int numeroAttivita(){
		int numAtt = 0;
		for(int j = 0; j < table.getRowCount(); j++){
			if(table.getValueAt(j,0)!=null){
				if(!((String)table.getValueAt(j,0)).equals("")){
					numAtt++;
				}
			}
		}
		return numAtt;
	}
	public boolean verificaDurate(){
		boolean dur = true;
		
		try{
			for(int i = 0; i < numeroAttivita(); i++){
				for(int j = 0; j < table.getRowCount(); j++){
					if((String)table.getValueAt(j,0)!=null){
						if(((String)table.getValueAt(j,0)).equals(ordina(attivita())[i])){
							int tmpDurata = Integer.parseInt(""+table.getValueAt(j,2));
						}
					}
				}
			}
		}catch(NumberFormatException ex){
			dur = false;
		}
		return dur;
	}
	public boolean verificaCosti(){
		boolean cos = true;
		try{
			for(int i = 0; i < numeroAttivita(); i++){
				for(int j = 0; j < table.getRowCount(); j++){
					if((String)table.getValueAt(j,0)!=null){
						if(((String)table.getValueAt(j,0)).equals(ordina(attivita())[i])){
							int tmpCosto = Integer.parseInt(""+table.getValueAt(j,3));
						}
					}
				}
			}
		}catch(NumberFormatException ex){
			cos = false;
		}
		return cos;
	}
	public boolean verificaFine(){
		String[] att = ordina(attivita());
		int fine = 0;
		for(int i = 0; i < att.length; i++){
			if(table.getValueAt(i,1)!=null){
				if(((String)table.getValueAt(i,1)).equals("Fine")){
					fine++;
				}
			}
		}
		
		if(fine == 1){
			return true;
		}else{
			return false;
		}
	}
	public boolean verificaPrecedenze(){
		int una = 0;
		for(int k = 0; k < table.getRowCount();k++){
			if(((String)table.getValueAt(k,4))!=null){
				if(!((String)table.getValueAt(k,4)).equals("")){
					una++;
					break;
			
				}
			}
		}
		if(una>0)
			return true;
		else{
			return false;
		}
	}
	
	public String[] listaDescrizioni(){
		String[] listaAtt = ordina(attivita());
		
		String[] descrizioni = new String[listaAtt.length];
		
		for(int i = 0; i < descrizioni.length; i++){
			for(int j = 0; j < table.getRowCount(); j++){
				if((String)table.getValueAt(j,0)!=null){
					if(((String)table.getValueAt(j,0)).equals(listaAtt[i])){
						if( table.getValueAt(j,3)!=null)
							descrizioni[i] = (String) table.getValueAt(j,5);
					}
				}
			}
		}
		
		return descrizioni;
	}
	public int[] listaCosti(){
		
		String[] listaAtt = ordina(attivita());
		int[] costi = new int[listaAtt.length];
		
		for(int i = 0; i < costi.length; i++){
			for(int j = 0; j < table.getRowCount(); j++){
				if(table.getValueAt(j,0)!=null){
					if(((String)table.getValueAt(j,0)).equals(listaAtt[i])){
						if(table.getValueAt(j,3)!=null)
							costi[i] = Integer.parseInt((String) table.getValueAt(j,3));
					}
				}
			}
		}
		
		return costi;
		
	}
	public String[] attivita(){
		
		int numAtt = 0;
		for(int j = 0; j < table.getRowCount(); j++){
			if((String)table.getValueAt(j,0)!=null){
				if(!((String)table.getValueAt(j,0)).equals("")){
					numAtt++;
				}
			}
		}
		
		String[] lista = new String[numAtt]; //prima 100
		
		int inizio = 0;
		int fine = lista.length-1;
		
		for(int i = 0; i < table.getRowCount(); i++){
			if(table.getValueAt(i,1)!=null){
				if(((String)table.getValueAt(i,1)).equals("Inizio")){
					if(table.getValueAt(i,0)!=null)
						if(!((String)table.getValueAt(i,0)).equals("")){
							lista[0] = (String)table.getValueAt(i,0);
							inizio = i;
						}
				}
				if(((String)table.getValueAt(i,1)).equals("Fine")){
					lista[numAtt-1] = (String)table.getValueAt(i,0);
					if(table.getValueAt(i,0)!=null)
						if(!((String)table.getValueAt(i,0)).equals("")){
							lista[numAtt-1] = (String)table.getValueAt(i,0);
							fine = i;
						}
				}
			}
		}
		
		int ind = 1;
		for(int k=0; k < table.getRowCount();k++){
			if(table.getValueAt(k,0)!=null){
				if(!((String)table.getValueAt(k,0)).equals("")){
					if(k!=inizio&&k!=fine){
						lista[ind] = (String)table.getValueAt(k,0);
						ind++;
					}
				}
			}
		}
		return lista;
	}
	public String[] ordina(String[] lista){
		
		String[] listaOrd = lista;
		
		int k = 0;
		while(k<listaOrd.length){
			for(int i = 0; i < listaOrd.length; i++){
				for(int j = 0;j < listaOrd.length; j++){
					if(i<j){
						if(presente(listaPrecedenze(lista[j]),lista[i])){
							//scala e scambia
							String tmp = listaOrd[i];
							for(int l =i+1; l <= j; l++){
								listaOrd[l-1] = listaOrd[l];
							}
							listaOrd[j] = tmp;
							i = j;
						}
					}
				}
			}
			k++;
		}
				
		return listaOrd;
	}

	public String[] listaPrecedenze(String att){
		String[] prec = new String[righe.length];
		int i = 0;
		
		for(int k = 0; k < righe.length;k++){
			if(((String)table.getValueAt(k,0))!=null){
				if(((String)table.getValueAt(k,0)).equals(att)){
					if(((String)table.getValueAt(k,4))!=null){
						if(!((String)table.getValueAt(k,4)).equals("")){
							StringTokenizer tmp = new StringTokenizer((String)table.getValueAt(k,4));	
							while(tmp.hasMoreTokens()){
								String s = (String) tmp.nextToken();
								prec[i] = s;
								i++;
							}
						}
					}
				}
			}
		}
		return prec;	
	}
	public int sommaDurateAttivita(String[] lista){
		int somma = 0;
		for(int j = 0; j < lista.length; j++){
			if(lista[j]!=null){
				somma = somma + getDurata(lista[j]);
			}
		}
		return somma;
	}
	public boolean[][] creaMatriceSel(){
		int r = 1;
		int c = 0;
		
		String[] listaAtt = ordina(attivita());
			
		boolean[][] sel = new boolean[listaAtt.length][sommaDurateAttivita(listaAtt)];
		
		//metto a false tutta la matrice
		for(int i = 0; i < sel.length;i++){
			for(int j = 0; j < sel[0].length; j++){
				sel[i][j] = false;
			}
		}

		String[][] cammini = new String[listaAtt.length][2];
		
		for(int k = 0;k < listaAtt.length;k++){	
			if(k==0){
				for(int i = 0; i < getDurata(listaAtt[k]);i++){
					sel[k][c] = true;
					c++;
				}
				cammini[k][0] = listaAtt[k];
				cammini[k][1] = "" + getDurata(listaAtt[k]);
			}else{
				c = getCamminoMax(cammini,listaAtt,k);
				cammini[k][0] = listaAtt[k];

				int tmp = c + getDurata(listaAtt[k]);
				cammini[k][1] = "" + tmp;
				
				for(int i = 0; i < getDurata(listaAtt[k]);i++){
					sel[k][c] = true;
					c++;
				}
			}
		}
		
		return sel;
	}
	
	public int getCamminoMax(String[][] c,String[] listaAtt,int k){
		String[] prec = new String[k];
		
		for(int i = 0;i < k ; i++){
			if(presente(listaPrecedenze(listaAtt[i]),listaAtt[k])){
				prec[i] = listaAtt[i];
			}
		}
		
		int max = maxCammino(c,prec);
		return max;
	}
	public int maxCammino(String[][] c, String[] lista){
		int max = 0;
		for(int i = 0; i < lista.length; i++){
			if(lista[i]!=null){
				for(int j = 0; j < c.length; j++){
					if(c[j][0]!=null){
						if(c[j][0].equals(lista[i])){
							if(Integer.parseInt(c[j][1]) >= max)
								max = Integer.parseInt(c[j][1]);
						}
					}
				}
			}
		}
		
		return max;
	}

	public int getDurata(String att){
		int dura = 0;
		for(int i = 0; i < table.getRowCount();i++){
			if((String)table.getValueAt(i,0)!=null){
				if(((String)table.getValueAt(i,0)).equals(att)){
					dura = Integer.parseInt(""+table.getValueAt(i,2));
					break;
				}
			}
		}
		return dura;
	}
	public boolean presente(String[] a, String m){
		for(int i = 0; i < a.length; i++){
			if(a[i]!=null)
				if(a[i].equals(m))
					return true;
		}
		return false;
	}
	public boolean[][] getMatriceAdiacenza(){
		String[] listaAtt = ordina(attivita());
		
		boolean[][] matrice = new boolean[listaAtt.length][listaAtt.length];
		for(int i = 0; i < matrice.length; i++){
			for(int j = 0; j < matrice[0].length; j++){
				matrice[i][j] = false;
			}
		}
		
		for(int i = 0; i <listaAtt.length; i++){
			for(int j = 0; j < listaAtt.length; j++){
				if(i!=j){
					if(presente(listaPrecedenze(listaAtt[i]),listaAtt[j])){
						matrice[i][j] = true;
					}
				}
			}
		}
		
		return matrice;
	}
	public int[] getListaDurate(){
		
		String[] listaAtt = ordina(attivita());
		int[] listaDurate = new int[listaAtt.length];
		
		for(int i = 0; i < listaAtt.length; i++){
			listaDurate[i] = getDurata(listaAtt[i]);
		}
		
		return listaDurate;
	}
	public void eliminaPrecedenze(){
		for(int i = 0; i < table.getRowCount(); i++){
			table.setValueAt("",i,4);
		}
	}
	public void eliminaAttivita(){
		for(int i = 0; i < table.getRowCount(); i++){
			for(int j = 0; j < table.getColumnCount(); j++){
				table.setValueAt("",i,j);
			}
		}
	}
	public CustomModel getModel(){
		return model;
	}
}

public class PanelCostruzione extends JPanel{
	//pannelli 
	Panel1 panel1;
	Panel2 panel2;
	
	FrameScelta frame;
	
	//Stato 
	int stato;
	
	//diagramma
	String nome;
	
	public PanelCostruzione(String diagramma,FrameScelta f){
		this.setLayout(null);
		this.setBounds(0,0,800,500);
		this.setBackground(Color.white);
		this.setName(diagramma);
		this.setVisible(false);
		
		stato = 1;
		nome = diagramma;
		frame = f;
		
		panel1 = new Panel1(stato,nome);
		panel2 = new Panel2(nome,panel1);
		
		this.add(panel1);
		this.add(panel2);
	}
	public void SetNullPanel(){
		panel1 = null;
		panel2 = null;
	}
	public boolean[][] getMatriceAdiacenza(){
		return panel2.getMatriceAdiacenza();
	}
	public void setDiagramma(String n){
		nome = n;
		panel1.setNome(nome);
	}
	public String getNome(){
		return panel1.getNome();
	}
	public int[] getListaCosti(){
		return panel2.listaCosti();
	}
	public String[] getDescrizioni(){
		return panel2.listaDescrizioni();
	}
	public int[] getListaDurate(){
		return panel2.getListaDurate();
	}
	public String[] getListaAttivitaOrdinata(){
		return panel2.ordina(panel2.attivita());
	}
	public String[] getListaAttivita(){
		return panel2.ordina(panel2.attivita());
	}
	public boolean[][] getMatriceSel(){
		return panel2.creaMatriceSel();
	}
	public String getInizio(){
		return panel1.getInizio();
	}
	public String getDeadLine(){
		return panel1.getDeadLine();
	}
	public void setEnabledPanel1(boolean t){
		panel1.setEnabled(t);
		panel1.setIntestazione(stato,nome);
	}
	public void setEnabledPanel2Resto(boolean t){
		panel2.setEnabledResto(t);
		panel1.setIntestazione(stato,nome);
	}
	public void setEnabledPanel2Prec(boolean t){
		if(t)
			panel2.addFinestra();
		
		panel2.setEnabledPrec(t);
		panel1.setIntestazione(stato,nome);
	}
	public int getStato(){
		return stato;
	}
	public void nextStato(){
		if(stato<2){
			stato++;
		}
	}
	public void prewStato(){
		if(stato>1){
			stato--;
		}
	}
	public void indietro(){
		if(stato == 2){
			panel2.eliminaPrecedenze();
			panel1.setEnabled(true);
			panel2.setEnabledPrec(false);
			panel2.setEnabledResto(true);
			stato = 1;
		}
		else if(stato == 1){
			panel1 = null;
			panel2 = null;
			frame.zeroVisible();
		}
	}
	public void reset(){
		stato = 1;
		panel1.reset();
		panel2.reset();
	}
	public boolean verificaInizio(){
		return panel2.verificaInizio();
	}
	public boolean verificaPrecedenze(){
		return panel2.verificaPrecedenze();
	}
	public boolean verificaDeadLine(){
		return panel1.verificaDeadLine();
	}
	public boolean verificaFine(){
		return panel2.verificaFine();
	}
	public boolean verificaDurate(){
		return panel2.verificaDurate();
	}
	public boolean verificaCosti(){
		return panel2.verificaCosti();
	}
	public boolean verificaPanel1(){
		return panel1.verificaPanel1();
	}
	public boolean verificaAttivita(){
		return panel2.verificaAttivita();
	}
	public boolean verificaAttivitaInizio(){
		return panel2.verificaAttivitaInizio();
	}
	public boolean verificaAttivitaFine(){
		return panel2.verificaAttivitaFine();
	}
	
	public void popola(String nome,String inizio, String dead,String[] listaAttivita,int[] listaDurate,boolean[][] matriceAd,int[] listacosti,String[] descrizioni){
		stato = 1;
		
		// nome inizio deadLine
		panel1.setNome(nome);
		panel1.setInizio(inizio);
		panel1.setDeadLine(dead);
		
		//attivita
		for(int i = 0; i < listaAttivita.length;i++){
			panel2.getModel().setValueAt(listaAttivita[i],i,0);
		}
		
		//set inizio e fine
		for(int i = 0; i < panel2.getModel().getRowCount(); i++){
			panel2.getModel().setValueAt("",i,1);
		}
		panel2.getModel().setValueAt("Inizio",0,1);
		panel2.getModel().setValueAt("Fine",listaAttivita.length-1,1);
		
		//durate
		for(int i = 0; i < listaDurate.length;i++){
			panel2.getModel().setValueAt(""+listaDurate[i],i,2);
		}
		
		//costi
		for(int i = 0; i < listacosti.length;i++){
			panel2.getModel().setValueAt(""+listacosti[i],i,3);
		}
		
		//descrizioni
		
		for(int i = 0; i < descrizioni.length;i++){
			panel2.getModel().setValueAt(descrizioni[i],i,5);
		}
		
		//precedenze
		
		String[] prec = new String[listaAttivita.length];
		for(int i = 0; i < prec.length;i++)
			prec[i] = "";
		
		for(int i = 0; i < matriceAd.length; i++){
			for(int j = 0; j < matriceAd[0].length;j++){
				if(matriceAd[i][j]){
					prec[i] = prec[i] + " " + listaAttivita[j];
				}
			}
		}
		
		for(int i = 0; i < prec.length;i++){
			if(prec!=null)
				panel2.getModel().setValueAt(prec[i],i,4);
		}
		
	}
}