import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class PanelOpzioniDiagramma extends JPanel{
	JButton diagramma;
	JButton modificaGantt;
	JButton modificaPert;
	
	public PanelOpzioniDiagramma(String diag,Principale p){
		this.setLayout(null);
		this.setBorder(BorderFactory.createBevelBorder(1));
	
		modificaGantt = new JButton("Modifica Gantt");
		modificaGantt.addActionListener(p);
		diagramma = new JButton();
		diagramma.addActionListener(p);
		modificaPert = new JButton("Modifica Pert");
		modificaPert.addActionListener(p);
		
		modificaGantt.setFont(new Font("INTESTAZIONE",Font.BOLD,12));
		modificaPert.setFont(new Font("INTESTAZIONE",Font.BOLD,12));
		diagramma.setFont(new Font("INTESTAZIONE",Font.BOLD,12));
		
		if(diag.equals("Gantt")){
			modificaGantt.setBounds(150,2,200,18);
			diagramma.setText("Visualizza Pert");
			diagramma.setActionCommand("Visualizza Pert");
			diagramma.setBounds(650,2,200,20);
			
			this.add(modificaGantt);
			this.add(diagramma);
			
		}else if(diag.equals("Pert")) {
			modificaPert.setBounds(150,2,200,18);
			diagramma.setText("Visualizza Gantt");
			diagramma.setActionCommand("Visualizza Gantt");
			diagramma.setBounds(650,2,200,20);
			
			this.add(modificaPert);
			this.add(diagramma);
		}else{
			modificaGantt.setBounds(150,2,200,18);
			modificaPert.setBounds(650,2,200,20);
			
			this.add(modificaGantt);
			this.add(modificaPert);
		}
	}
}