import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class PanelZero extends JPanel{
	FrameScelta frame;
	
	JLabel intestazione;
	
	JLabel image;
	
	JRadioButton gantt;
	JRadioButton pert;
	ButtonGroup group;
	
	ActionListener listener;
	MouseListener mouselistener;
	
	public PanelZero(FrameScelta f){
		
		frame = f;
		listener = f;
		mouselistener = f;
		
		intestazione = new JLabel("Cosa voui fare?");
		
		image = new JLabel(new ImageIcon(""));
		image.setBounds(250,100,450,400);
		
		gantt = new JRadioButton("Gantt");
		pert = new JRadioButton("Pert");
		
		gantt.setBackground(Color.white);
		pert.setBackground(Color.white);
		
		gantt.setToolTipText("Costruzione diagramma Gantt e verifica formale proprieta");
		pert.setToolTipText("Costruzione diagramma Pert e verifica formale proprieta");
		
		gantt.addMouseListener(mouselistener);
		pert.addMouseListener(mouselistener);
		
		gantt.addActionListener(listener);
		pert.addActionListener(listener);
		
		group = new ButtonGroup();
		group.add(gantt);
		group.add(pert);
		
		intestazione.setBounds(50,100,100,30);
		gantt.setBounds(50,150,100,30);
		pert.setBounds(50,190,100,30);

		this.add(intestazione);
		this.add(image);
		this.add(gantt);
		this.add(pert);
		
		this.setName("ZERO");
		this.setBackground(Color.white);
		this.setLayout(null);
		this.setBorder(BorderFactory.createEtchedBorder());
		this.setBounds(0,0,800,500);
		this.setVisible(true);
	}
	public void resetSelection(){
		gantt.setSelected(false);
		pert.setSelected(false);
	}
	public String getSelezione(){
		if(gantt.isSelected())
			return "Gantt";
		else if(pert.isSelected())
			return "Pert";
		else
			return "null";
	}
	public void setImage(String img){
		image.setIcon(new ImageIcon(img));
	}
	public Component getGantt(){
		return gantt;
	}
	public Component getPert(){
		return pert;
	}
}